/* $Header: mthreads.h,v 4.3.3.3 91/01/16 03:16:33 davison Trn $
**
** $Log:	mthreads.h,v $
** Revision 4.3.3.3  91/01/16  03:16:33  davison
** Added optional prototyping.
** 
** Revision 4.3.3.2  90/08/20  16:44:29  davison
** New entries for new command-line interface.
** 
** Revision 4.3.3.1  90/06/20  22:55:27  davison
** Initial Trn Release
** 
*/

#ifdef lint
#include "mt-lint.h"
#endif
#include "threads.h"

EXT TOTAL total;

EXT int processed_groups;
EXT int added_articles, added_count;
EXT int expired_articles, expired_count;
EXT bool extra_expire INIT(FALSE);
EXT int caught_interrupt INIT(0);

EXT char *strings INIT(0);
EXT WORD *subject_cnts INIT(0);
EXT WORD *author_cnts INIT(0);
EXT WORD *ids INIT(0);

EXT SUBJECT **subject_array;
EXT ROOT **root_array;
EXT AUTHOR **author_array;
EXT ARTICLE **article_array;

EXT PACKED_ROOT p_root;
EXT PACKED_ARTICLE p_article;

EXT ROOT *root_root;
EXT AUTHOR *author_root;

#ifndef DOINIT
EXT DOMAIN unk_domain;
#else
DOMAIN unk_domain = {
    ".unknown.", NULL, NULL
};
#endif

int ngmatch ANSI((char *,char *));
int onepatmatch ANSI((char *,char *));

void log_entry();
void log_error();

void mybytemap ANSI((BMAP *));
int read_data ANSI((void));
int write_data ANSI((char *));
void dont_read_data ANSI((int));

void process_articles ANSI((ART_NUM,ART_NUM));

char *thread_name ANSI((char *));
char *file_exp ANSI((char *));
char *savestr ANSI((char *));

#ifndef lint
char *safemalloc ANSI((MEM_SIZE));
void free();
void safefree();
#endif

time_t getdate ANSI((char *,time_t,long));

#define Nullart Null(ARTICLE*)
